/*
 * devicesettings.h
 *
 * Created: 18.02.2020 22:21:24
 *  Author: Chris
 */ 


#ifndef DEVICESETTINGS_H_
#define DEVICESETTINGS_H_

#include <avr/eeprom.h>
#include <stdbool.h>
#include <usbdrv.h>

#define KBSEQ_LENGTH 128

#define INTERFACE_MODE_MAX 3
typedef enum
{
    ifmode_hid = 0,
    ifmode_kbd_key = 1,
    ifmode_kbd_seq = 2,
    ifmode_pad = 3,
    // if modes modified, check INTERFACE_MODE_MAX!
}   ifmode_t;

typedef enum
{
    dscmd_nop = 0, // used for button state
    dscmd_restart = 1,
    dscmd_getifmode = 2,
    dscmd_setifmode = 3,
    dscmd_getkbdkey = 4,
    dscmd_setkbdkey = 5,
    dscmd_getkbseq = 6,
    dscmd_setkbseq = 7,
    // TODO: implement serial number
    //dscmd_getsnr = 8, 
    //dscmd_setsnr = 9,
}   dscmd_t;

typedef enum
{
    dsresp_none = 0<<6,
    dsresp_busy = 1<<6,
    dsresp_ok = 2<<6,
    dsresp_error = 3<<6,
}   dsresp_t;

typedef struct
{
    //dsresp_t status; // status is embedded in data
    //dscmd_t cmd; // command is embedded in data
    uint8_t data[8];
    //uint8_t datapos;
    bool dataready;
} ds_respdata_t;

extern ifmode_t interface_mode;
extern uint8_t vt_key_keycode[2];
extern uint8_t vt_kbseq[128];

extern ds_respdata_t ds_response;

void ds_cmdReceived(uchar* buffer);
void ds_loadifmode(void);
void ds_loadkbdkey(void);
void ds_loadkbseq(void);

dsresp_t ds_task(void);
#endif /* DEVICESETTINGS_H_ */