from enum import Enum

class KeycodeConverter_de():
    CHARS = [
        ['a', 0x04, 0x00],['A', 0x04, 0x00],
        ['b', 0x05, 0x00],['B', 0x05, 0x00],
        ['c', 0x06, 0x00],['C', 0x06, 0x00],
        ['d', 0x07, 0x00],['D', 0x07, 0x02],
        ['e', 0x08, 0x00],['E', 0x08, 0x02],['€', 0x80, 0x05],
        ['f', 0x09, 0x00],['F', 0x09, 0x02],
        ['g', 0x0A, 0x00],['G', 0x0A, 0x02],
        ['h', 0x0B, 0x00],['H', 0x0B, 0x02],
        ['i', 0x0C, 0x00],['I', 0x0C, 0x02],
        ['j', 0x0D, 0x00],['J', 0x0D, 0x02],
        ['k', 0x0E, 0x00],['K', 0x0E, 0x02],
        ['l', 0x0F, 0x00],['L', 0x0F, 0x02],
        ['m', 0x10, 0x00],['M', 0x10, 0x02],['µ', 0x10, 0x05],
        ['n', 0x11, 0x00],['N', 0x11, 0x02],
        ['o', 0x12, 0x00],['O', 0x12, 0x02],
        ['p', 0x13, 0x00],['P', 0x13, 0x02],
        ['q', 0x14, 0x00],['Q', 0x14, 0x02],['@', 0x14, 0x05],
        ['r', 0x15, 0x00],['R', 0x15, 0x02],
        ['s', 0x16, 0x00],['S', 0x16, 0x02],
        ['t', 0x17, 0x00],['T', 0x17, 0x02],
        ['u', 0x18, 0x00],['U', 0x18, 0x02],
        ['v', 0x19, 0x00],['V', 0x19, 0x02],
        ['w', 0x1A, 0x00],['W', 0x1A, 0x02],
        ['x', 0x1B, 0x00],['X', 0x1B, 0x02],
        ['z', 0x1C, 0x00],['Z', 0x1C, 0x02],
        ['y', 0x1D, 0x00],['Y', 0x1D, 0x02],
        ['ü', 0x2F, 0x00],['Ü', 0x2F, 0x02],
        ['ö', 0x33, 0x00],['Ö', 0x33, 0x02],
        ['ä', 0x34, 0x00],['Ä', 0x34, 0x02],
        ['°', 0x35, 0x02],['^', 0x35, 0x00],
        ['1', 0x1E, 0x00],['!', 0x1E, 0x02],
        ['2', 0x1F, 0x00],['"', 0x1F, 0x02],['²', 0x1F, 0x05],
        ['3', 0x20, 0x00],['§', 0x20, 0x02],['³', 0x20, 0x05],
        ['4', 0x21, 0x00],['$', 0x21, 0x02],
        ['5', 0x22, 0x00],['%', 0x22, 0x02],
        ['6', 0x23, 0x00],['&', 0x23, 0x02],
        ['7', 0x24, 0x00],['/', 0x24, 0x02],
        ['8', 0x25, 0x00],['(', 0x25, 0x02],
        ['9', 0x26, 0x00],[')', 0x26, 0x02],
        ['0', 0x27, 0x00],['=', 0x27, 0x02],
        ['ß', 0x2D, 0x00],['?', 0x2D, 0x02],['\\', 0x2D, 0x05],['ẞ', 0x2D, 0x07],
        ['´', 0x2E, 0x00],['`', 0x2E, 0x02],
        ['+', 0x30, 0x00],['*', 0x30, 0x02],['~', 0x30, 0x05],
        ['#', 0x32, 0x00],['\'', 0x32, 0x02],
        [',', 0x36, 0x00],[';', 0x36, 0x02],
        ['.', 0x37, 0x00],[':', 0x37, 0x02],
        ['-', 0x38, 0x00],['_', 0x38, 0x02],
        ['<', 0x64, 0x00],['>', 0x64, 0x02],['|', 0x64, 0x05],
        [' ', 0x2C, 0x00],
        ['\t', 0x2B, 0x00],
        ['\n', 0x28, 0x00],
    ]

    CTRLS =  [
        ['Enter', 0x28, 0x00],
        ['Esc', 0x29, 0x00],
        ['Backspace', 0x2A, 0x00],
        ['Tab', 0x2B, 0x00],
        ['F1', 0x3A, 0x00],
        ['F2', 0x3B, 0x00],
        ['F3', 0x3C, 0x00],
        ['F4', 0x3D, 0x00],
        ['F5', 0x3E, 0x00],
        ['F6', 0x3F, 0x00],
        ['F7', 0x40, 0x00],
        ['F8', 0x41, 0x00],
        ['F9', 0x42, 0x00],
        ['F10', 0x43, 0x00],
        ['F11', 0x44, 0x00],
        ['F12', 0x45, 0x00],
        ['PrintScreen', 0x46, 0x00],
        ['Pause', 0x48, 0x00],
        ['Insert', 0x49, 0x00],
        ['Home', 0x4A, 0x00],
        ['PgUp', 0x4B, 0x00],
        ['Del', 0x4C, 0x00],
        ['End', 0x4D, 0x00],
        ['PgDn', 0x4E, 0x00],
        ['CursorRight', 0x4F, 0x00],
        ['CursorLeft', 0x50, 0x00],
        ['CursorDown', 0x51, 0x00],
        ['CursorUp', 0x52, 0x00],
        ['KeypadSlash', 0x54, 0x00],
        ['KeypadAsterisk', 0x55, 0x00],
        ['KeypadMinus', 0x56, 0x00],
        ['KeypadPlus', 0x57, 0x00],
        ['KeypadEnter', 0x58, 0x00],
        ['Keypad1', 0x59, 0x00],
        ['Keypad2', 0x5A, 0x00],
        ['Keypad3', 0x5B, 0x00],
        ['Keypad4', 0x5C, 0x00],
        ['Keypad5', 0x5D, 0x00],
        ['Keypad6', 0x5E, 0x00],
        ['Keypad7', 0x5F, 0x00],
        ['Keypad8', 0x60, 0x00],
        ['Keypad9', 0x61, 0x00],
        ['Keypad0', 0x62, 0x00],
        ['KeypadDot', 0x63, 0x00],
    ]

    @classmethod
    def get_entry_for_char(cls, char):
        for e in cls.CHARS:
            if char == e[0]:
                return e
        return None

    @classmethod
    def string_to_keycodes(cls, text):
        codes = []
        for c in text:
            code = cls.get_entry_for_char(c)
            if code is None:
                print('\'%s\' could not be converted' % c)
            else:
                codes.append(code)
        return codes

